#include <bits/stdc++.h>

using namespace std;
double dalj[1000010];
int main(int argc, char** argv) {
	int h,q,w,r,a,x,y;
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);		
	cin>>w>>h>>r>>q;
	for(int i=0;i<w;i++)dalj[i]=h;
	for(int i=0;i<q;i++)
	{
		cin>>a;
		if(a==1)
		{
			cin>>x>>y;
			for(int j=max(x-r,0);j<=min(x+r,w);j++)
			{
				int tr=x-j;
				double dtr=y-sqrt(r*r-tr*tr);
				if(dalj[j]>dtr)dalj[j]=dtr;
			}
		}
		else
		{
			cin>>x;
			cout<<dalj[x]<<endl;
		}
	}
	return 0;
}